<template xmlns="">
  <!-- Eingabe der Freiheitsgrade -->
  <div v-if="currentFamily.parameters" class="center-input" v-for="(parameter, index) in currentFamily.parameters">
    <label> {{ parameter.label }} </label>
    <!--updownarrows type="number"-->
    <input v-model.number="currentFamily.parameters[index].value" @change="onChange" @input="filterInput">
  </div>
    <div class="center-input">
  <button class="center" @click="togglePath">{{ (movePath ? "fixierte" : "verschiebbare") + " Fünfecke" }}</button>
  <button class="center" @click="resetCanvas">Reset</button>
  </div>
  <canvas resize ref="tilingCanvas" class="tiling-canvas"
          @mousedown="onMouseDown">
  </canvas>

</template>

<script setup>
//TODO: an jede Veränderung die selbst durch mein programm vorgenommen wird, muss nochmal das valibot ding gecalled werden
import {computed, ref} from 'vue'
import {Group, PaperScope, Path, Point, Tool} from 'paper'
import {array, every, number, object, parse} from 'valibot';
import {degreeToRadian, lawOfCosine, radianToDegree} from "~/composables/MathOperations.js";

let familyType = useFamilyTypeStore() //welche familie gerade ausgewählt ist und wie das fünfeck verändert wurde
let currentFamily = computed(() => getFamilyByCombinedName(familyType.name)); //das jetzige familienobject mit allen daten und der validierungsfunktion

const UNDEF = undefined;
const FamilyTileSchema = object({
      angles: array(number(), [every(angle => angle <= 180, "Not convex")]),
      strokes: array(number([])),
    },
);


let tool = null //paper.Event() //paper.KeyEvent()
const scope = ref(new PaperScope())
const tilingCanvas = ref(null) //the canvas representing all polygons
let movePath = ref(false);
let primUnits = [];

let points = computed(() => currentFamily.value.angles.length);
let hitOptionsPath = {
  class: Path,
  segments: true,
  stroke: false,
  fill: true,
  tolerance: 20,
};

let hitResult = null;

//properties of the polygon, when hitting a segment(point) (one angle and two sidelengths can be changed)
let groupHit = null,
    pathHit = null,  //the path object representing the polygon, which is being hit
    segmentHit = null; /*the segment which is being hit*/

const onChange = () => {
  currentFamily.value.angles = [UNDEF, UNDEF, UNDEF, UNDEF, UNDEF];
  currentFamily.value.strokes = [UNDEF, UNDEF, UNDEF, UNDEF, UNDEF];
  currentFamily.value.angles.map(Number);
  currentFamily.value.strokes.map(Number);
  currentFamily.value.init();
  resetCanvas();
}
watch(() => familyType.name, () => {
  resetCanvas();
});

const filterInput = (event) => {
  event.target.value = event.target.value.replace(/[^0-9.]/g, '');
}

const togglePath = () => {
  movePath.value = !(movePath.value);
}

const hardReset = () => {
  //Problem: Input Feld wird nicht geupdated
  for (let i = 0; i < currentFamily.value.parameters.length; i++) {
    //currentFamily.value.parameters[i].value = currentFamily.value.defaultValues[i];
  }
  currentFamily.value.init();
  resetCanvas();
}

onMounted(() => {
  tool = new Tool()
  scope.value.setup(tilingCanvas.value)
  //paper.setup(tilingCanvas.value)
  createPaths();
  //scope.value.view.draw()
  //console.log(allPaths)
})


const createPaths = () => {
  if(!currentFamily.value) {
    console.error("No family was found. What happened?");
    return;
  }
  if(currentFamily.value.strokes.length === 0) {
    currentFamily.value.init();
  }
  if(!checkStrokes()) {
    return;
  }

  //console.log("Seiten_soll:", currentFamily.value.strokes);
  //console.log("Winkel_soll:", currentFamily.value.angles);

  let path;
  const pUnit = currentFamily.value.primitiveUnit;
  //In den for loop muss jetzt eine Bedingung wie "bis der canvas voll ist"
  console.assert(pUnit.count <= pUnit.colors.length, "Not enough colors given for primitive Unit creation")
  console.assert(pUnit.count <= pUnit.rotation.length, "Not enough rotational parameters given for primitive Unit creation");
  console.assert(pUnit.count <= pUnit.connection.length, "Not enough connection parameters given for primtive Unit creation");


  let primUnit = new Group();
  //for each element in primitive Unit
  for (let i = 0; i < pUnit.count; i++) {
    //path creation
    const color = pUnit.colors[i];
    const rot = pUnit.rotation[i];
    const connections = pUnit.connection[i];
    path = createTile(color, pUnit.clockwise[i]);
    path.parent = primUnit;

    primUnits.push(primUnit);

    //weil das neuste path objekt schon hinzugefügt ein, müssen wir das vorletzte array element nehmen
    let lastPath = i >= 1 ? primUnit.children[primUnit.children.length - 2] : path;
    //wenn das erste element bewegt werden soll, besitzt die Liste noch keine 2 elemente

    //path rotation
    if(rot.s1s1 !== UNDEF && rot.s1s2 !== UNDEF && rot.s2s1 !== UNDEF && rot.s2s2 !== UNDEF) {
      let seg11 = path.segments[rot.s1s1], seg21 = lastPath.segments[rot.s2s1];
      let seg12 = path.segments[rot.s1s2], seg22 = lastPath.segments[rot.s2s2];
      let stroke1 = seg11.point.subtract(seg12.point), stroke2 = seg21.point.subtract(seg22.point);

      let angle = stroke1.getDirectedAngle(stroke2);
      //console.log(angle);
      path.rotate(angle);//default is center bei path.rotate();
      path.data.rotation = angle;
    }

    //path connection
    if(connections.length === 2 && connections[0] < points.value && connections[1] < points.value) {
      //console.log("Segment ", connections[1], " wird zu Segment ", connections[0], " bewegt")
      connect(lastPath, path, lastPath.segments[connections[1]], path.segments[connections[0]])
    }
  }
  primUnit.position = scope.value.view.center;
  //group.clone();
  //group.bounds.width;
  //group.bounds.height;
  //let offset = new Point(0,0);
  //group.position = group.position.add(offset);


  for (let i = 0; i < pUnit.offset.length; i++) {
    if(pUnit.offset[i].childId1 !== UNDEF && pUnit.offset[i].childId2 !== UNDEF &&
        pUnit.offset[i].segment1 !== UNDEF && pUnit.offset[i].childId2 !== UNDEF) {
      let newUnit = primUnit.clone();

      let offSetValues = pUnit.offset[i];
      let posFirstChild = primUnit.children[offSetValues.childId1].segments[offSetValues.segment1].point;
      let posSecondChild = primUnit.children[offSetValues.childId2].segments[offSetValues.segment2].point;

      let diff = posFirstChild.subtract(posSecondChild);
      //let newPosition = primUnit.position.add(diff);
      newUnit.position = primUnit.position.add(diff);
      primUnits.push(newUnit);
    }
    /*if new position doesnt already contain a primunit*/
  }


  //primUnit.addTo(scope.value.project);
  //primUnit.addTo(scope.value.view);
  //group.rotate(-55);
  //group.position = group.position.add(new Point(-100, 100));
  //setNewCenter(path, scope.value.view.center)
}
/**
 *
 * @param color
 * @param clockwise
 * @returns {paper.Path}
 */
const createTile = (color, clockwise) => {
  //Hier wird auf Basis der Familie jetzt das Fünfeck erstellt
  let path = new Path({
    closed: true,
    fillColor: color,
    strokeWidth: 3,
    strokeColor: 'black',
    data: {rotation: 0},
  });
  let delta = scope.value.view.center;
  let angle = 0;
  for (let i = 0; i < points.value; i++) {
    delta = delta.add(new Point({
      length: currentFamily.value.strokes[i],
      angle: angle,
    }));
    angle += 180 + (clockwise ? -currentFamily.value.angles[i] : currentFamily.value.angles[i]);

    path.add(delta);
  }
  //TODO: Das hier noch entfernen
  //wenn ich später primitive Units erstelle, kann man immernoch nachdem man createTile aufgerufen hat das Ding drehen und schieben
  //setNewCenter(path, scope.value.view.center);
  return path;
}
/**
 * moves polygon2, such that it connects to polygon1 at segment1
 * @param polygon1
 * @param polygon2
 * @param segment1
 * @param segment2
 */
const connect = (polygon1, polygon2, segment1, segment2) => {
  console.assert(polygon1.contains(segment1.point), "segment1 does not belong to polygon1");
  console.assert(polygon1.contains(segment1.point), "segment1 does not belong to polygon1");
  console.assert(polygon1.contains(segment1.point), "segment1 does not belong to polygon1");
  console.assert(polygon2.contains(segment2.point), "segment2 does not belong to polygon2");

  let diff = segment1.point.subtract(segment2.point)
  movePolygon(polygon2, diff);
}

/**
 * finds out for a given line defined by point1 and point2, the point on this line that is closest to point3
 * @param point1 point1 defining the line
 * @param point2 point2 defining the line
 * @param point3
 * @returns {paper.Point}
 */
const closestPointOnLine = (point1, point2, point3) => {
  //https://stackoverflow.com/a/47198877
  let pointD = point2.subtract(point1);
  let determinant = pointD.multiply(pointD).x + pointD.multiply(pointD).y;
  let a = (pointD.y * (point3.y - point1.y) + pointD.x * (point3.x - point1.x)) / determinant;
  return new Point(point1.x + a * pointD.x, point1.y + a * pointD.y);
}

/**
 * returns a directed vector with the same slope as vector one
 * @param point1 gives angle for new vector
 * @param point2 gives length for new vector
 * @returns {paper.Point} the new desired point
 */
const directedVector = (point1, point2) => {
  //let ang = point1.getDirectedAngle(point2);
  //let mult = Math.abs(ang) > 90 ? -1:+1;
  return new Point({length: point2.length, angle: point1.angle});//.multiply(mult);
}


/**
 * gibt zurück, ob zwei vektoren mit maximal 45 grad abweichung gleich orientiert sind
 * @param vec1
 * @param vec2
 * @returns {number}
 */
const sameDir = (vec1, vec2) => {
  let ang = vec1.getDirectedAngle(vec2);
  return Math.abs(ang) > 90 ? -1 : +1;
}

const onMouseDown = () => {
  scope.value.activate() //brauche ich das?
  tool.onMouseDown = (event) => {
    resetProperties();

    hitResult = scope.value.project.hitTest(event.point, hitOptionsPath);

    if(!hitResult) {
      return;
    }

    pathHit = hitResult.item;
    groupHit = pathHit.parent;


    //let [a, s] = calcPolyProperties(pathHit)
    //console.log("Index in Gruppe:", groupHit.getItem(pathHit).index);
    //console.log("Seitenlängen:", s)
    //console.log("Winkel:", a)
    //console.log("Rotation:", pathHit.data.rotation, "Uhrzeigersinn:", pathHit.clockwise);
    //  (dann kann ich auch easy, bei jedem change einfach redrawn)
    //allPaths.findIndex(p => calcCenter(p).subtract(calcCenter(path)).abs().length === 0); //--1 wenn nicht gefunden

    if(hitResult.type === 'segment') {
      segmentHit = hitResult.segment;
      //console.log(segmentHit.index, ":", getAngleFromSegment(segmentHit)[0], "@", segmentHit.point);
    }

    if(hitResult.type === 'fill') {
      scope.value.project.activeLayer.addChild(hitResult.item);
    }
  }

  tool.onMouseDrag = (event) => {
    if(!pathHit) {
      return;
    }

    let idx = 0;
    let move = event.delta;
    let tempPath = pathHit.clone({insert: false})

    if(hitResult.type === 'fill' && movePath.value) {
      pathHit.position = pathHit.position.add(move);
    }

    if(!segmentHit) {
      return;
    }
    idx = segmentHit.index;
    let tempSegment = tempPath.segments[idx];
    tempSegment.point = tempSegment.point.add(move);

    if(!validatePolygon(tempPath, {})) {
      return;
    }

    if(currentFamily.value.id === 1 && idx === 3) {
      pathHit.segments[idx].point = pathHit.segments[idx].point.add(move);
    }
    else if(currentFamily.value.id === 1) {
      let A = idx, B, C, D;
      pathHit.segments[idx].point = pathHit.segments[idx].point.add(move);
      switch (idx) {
        case 0:
          B = 4;
          C = idx = 1;
          D = 2;
          break;
        case 1:
          B = 2;
          C = idx = 0;
          D = 4;
          break;
        case 2:
          B = 1;
          C = idx = 4;
          D = 0;
          break;
        case 4:
          B = 0;
          C = idx = 2;
          D = 1;
          break;
      }
      A = pathHit.segments[A].point;
      B = pathHit.segments[B].point;
      C = pathHit.segments[C].point;
      D = pathHit.segments[D].point;

      let newSlope = Math.atan((A.y - B.y) / (A.x - B.x));
      let lengthOtherStroke = D.subtract(C).length
      let xChange = Math.cos(newSlope) * lengthOtherStroke;
      let yChange = Math.sin(newSlope) * lengthOtherStroke;
      //wenn man an den linken beiden Punkten anfasst muss das Steigungsdreieck anders herum angelegt werden
      let right = idx === 0 || idx === 1 ? 1 : -1;
      let rotated = equals(Math.abs(pathHit.data.rotation), 180) ? -1 : 1; //probably not exhaustive, but should do the job
      pathHit.segments[idx].point = D.add(new Point(xChange, yChange).multiply(right).multiply(rotated));
    }
    else if(currentFamily.value.id === 2) {
      let segments = pathHit.segments;
      let BC = segments[1].point.subtract(segments[2].point),
          ED = segments[4].point.subtract(segments[3].point);
      let mult = 0;
      // noinspection JSMissingSwitchDefault
      switch (idx) {
        case 0:
          //A wird nur entlang b bewegt
          let stroke = segmentHit.point.subtract(segmentHit.next.point);
          mult = sameDir(stroke, move);
          let mve = directedVector(stroke, move).multiply(mult);
          pathHit.segments[idx].point = segments[idx].point.add(mve);
          break;
        case 1:
        case 4:
          mult = sameDir((idx === 1 ? BC : ED), move);
          //B, A und E werden nach unten/oben gezogen
          let moveB = directedVector(BC, move).multiply(mult),
              moveE = directedVector(ED, move).multiply(mult);
          pathHit.segments[0].point = segments[0].point.add(moveB);
          pathHit.segments[1].point = segments[1].point.add(moveB);
          pathHit.segments[4].point = segments[4].point.add(moveE);
          break;
        case 2:
        case 3:
          mult = sameDir((idx === 2 ? BC : ED).multiply(-1), move);
          //C (entlang c) und D (entlang e) werden nach oben/unten gezogen
          let moveC = directedVector(BC.multiply(-1), move).multiply(mult),
              moveD = directedVector(ED.multiply(-1), move).multiply(mult);
          pathHit.segments[2].point = segments[2].point.add(moveC);
          pathHit.segments[3].point = segments[3].point.add(moveD);
          break;
      }
    }
    else if(currentFamily.value.id === 3 && (idx === 4 || idx === 1)) {
      let segs = pathHit.segments;

      let ED = segs[4].point.subtract(segs[3].point),
          BC = segs[1].point.subtract(segs[2].point);
      let mult = sameDir(idx === 1 ? BC : ED, move);
      let moveB = directedVector(BC, move).multiply(mult),
          moveE = directedVector(ED, move).multiply(mult);

      //Die Seiten müssen sich entgegengesetzt bewegen
      if(idx === 1) {
        moveE = moveE.multiply(-1);
      }
      else {
        moveB = moveB.multiply(-1);
      }

      pathHit.segments[1].point = segs[1].point.add(moveB);
      pathHit.segments[4].point = segs[4].point.add(moveE);

      let EB = pathHit.segments[1].point.subtract(pathHit.segments[4].point); //WARUM 1 - 4 UND NICHT ANDERSHERUM
      let bottomSide = EB.length;
      let desiredTopAngle = currentFamily.value.angles[0];
      let bottomAngle = (180 - desiredTopAngle) / 2;
      let hypotenuseLength = bottomSide * Math.sin(degreeToRadian(bottomAngle)) / Math.sin(degreeToRadian(desiredTopAngle));
      let hypotenuse = new Point({length: hypotenuseLength, angle: EB.angle - bottomAngle}); //-bottomAngle, weil clockwise
      pathHit.segments[0].point = pathHit.segments[4].point.add(hypotenuse);
    }
    else if(currentFamily.value.id === 4 && (idx === 0 || idx === 4)) {

      const rotSeg = pathHit.segments[2];
      let triangle = new Path({
        segments: [segmentHit.clone(), pathHit.segments[idx === 0 ? 1 : 3].clone(), rotSeg.clone()],
        insert: false,
        closed: true
      });
      let stroke = rotSeg.point.subtract(segmentHit.index.point); //gleichzeitig auch der Radius von dem Kreis
      let clockwise = sameDir(stroke, move);
      let angle = (360 * move.length) / (2 * Math.PI * stroke.length); //https://de.bettermarks.com/mathe/kreisausschnitt-und-kreisbogen/
      triangle.rotate(angle * clockwise, triangle.segments[2].point);
      pathHit.segments[idx].point = triangle.segments[0].point.clone();
      pathHit.segments[idx === 0 ? 1 : 3].point = triangle.segments[1].point.clone();
      pathHit.segments[2].point = triangle.segments[2].point.clone();
      triangle.remove();
    }
    else if(currentFamily.value.id === 5 && (idx === 1 || idx === 2)) {
      const rotSeg = pathHit.segments[4];
      let triangle = new Path({
        segments: [segmentHit.clone(), pathHit.segments[idx === 1 ? 0 : 3].clone(), rotSeg.clone()],
        insert: false,
        closed: true
      });
      let stroke = rotSeg.point.subtract(segmentHit.index.point); //gleichzeitig auch der Radius von dem Kreis
      let clockwise = sameDir(stroke, move);
      let angle = (360 * move.length) / (2 * Math.PI * stroke.length); //https://de.bettermarks.com/mathe/kreisausschnitt-und-kreisbogen/
      triangle.rotate(angle * clockwise, triangle.segments[2].point);
      pathHit.segments[idx].point = triangle.segments[0].point.clone();
      pathHit.segments[idx === 1 ? 0 : 3].point = triangle.segments[1].point.clone();
      pathHit.segments[4].point = triangle.segments[2].point.clone();
      triangle.remove();
    } else {
      //ohne dass hier kann man auch andere familien bewegen
      //wieso? idk
      return;
    }
    resetCanvas();
  };

  tool.onMouseUp = (event) => {
    //Daten an Header senden oder so
    if(pathHit != null) {
      [currentFamily.value.angles, currentFamily.value.strokes] = calcPolyProperties(pathHit)
    }
    ///Gute idee, braucht feinschliff
    //resetCanvas();
  };

  tool.onMouseMove = (event) => {
    scope.value.project.activeLayer.selected = false;
    if(event.item) {
      event.item.selected = true;
    }
  }
}

/**
 * moves the current clicked-on segment by a specified amount
 * @param move
 */
const freelyMoveSegment = (move) => {
  segmentHit.point = segmentHit.point.add(move);
}

/**
 * validates, whether the given path object satisfies the current family rules
 * @param polygon the path object to validate
 * @returns {boolean} valid or not
 */
const validatePolygon = (polygon) => {
  let [a, s] = calcPolyProperties(polygon)
  try {
    let tile = parse(FamilyTileSchema, {
      angles: a,
      strokes: s,
    })
    currentFamily.value.angles = tile.angles;
    currentFamily.value.strokes = tile.strokes;
  } catch (error) {
    //console.log(error);
    return false;
  }
  return true;
}

/**
 * deletes the canvas and redraws all polygons in their original states
 */
const resetCanvas = () => {
  scope.value.project.activeLayer.removeChildren();
  primUnits = [];
  createPaths();
};

/**
 * resets the currently selected objects
 */
const resetProperties = () => {
  groupHit = pathHit = segmentHit = null;
}

/**
 * calculates the angle of a given segment defined by the two strokes touching the segment
 * @param seg The given segment on a path
 * @returns {[number,number,number]} angle of the segment and the length of both strokes
 */
const getAngleFromSegment = (seg) => {
  //https://stackoverflow.com/a/37211434
  let vectorBefore = seg.point.subtract(seg.previous.point),
      vectorAfter = seg.point.subtract(seg.next.point),
      //TODO: vorsichtig pathHit
      angle = pathHit.clockwise ?
          vectorAfter.getDirectedAngle(vectorBefore) : vectorBefore.getDirectedAngle(vectorAfter);

  angle = mod(angle, 360);
  return [angle, vectorBefore.length, vectorAfter.length];
}

/**
 * Returns every angle and strokelength for a given polygon defined as a Path object
 * @param polygon the given path object
 * @returns {[number[],number[]]} the angles and stroke lenghts
 */
const calcPolyProperties = (polygon) => {
  let angs = [0, 0, 0, 0, 0]
  let strokeLengths = [0, 0, 0, 0, 0]
  for (let i = 0; i < points.value; i++) {
    [angs[i], strokeLengths[i],] = getAngleFromSegment(polygon.segments[i]);
  }
  return [angs, strokeLengths]
}

/**
 * Whenever the canvas gets (re)drawn, it is checked whether all sideLenghts for the tile are already defined,
 * or if 1 or 2 (no more) need to be calculated
 */
const checkStrokes = () => {
  let valid = true;
  //Each polygon has a different min req.
  //Here init all side lenghts based on these req.

  //Calculate missing strokelenghts:
  let firstOcc = currentFamily.value.strokes.findIndex(findUndefined),
      lastOcc = currentFamily.value.strokes.findLastIndex(findUndefined);
  let diff = lastOcc - firstOcc; //abs not neccessary (findLastIndex >= findIndex), but do it anyway, you never know
  let legal = diff <= 1 || diff === points.value - 1;
  if(firstOcc === lastOcc && firstOcc !== -1) {
    //console.warn("Polygon may not be drawn correctly, every stroke except one is given")
    //console.log(currentFamily.value.strokes)
  }
  if(firstOcc !== -1) {
    if(!legal) {
      //Wenn die beiden fehlenden Seiten nicht hintereinanderliegen
      //und nicht die letzte und erste zeitgleich sind [undef, b, c, d, undef]
      console.error("Cannot create polygon. Not enough given strokelenghts in succession")
      valid = false;
    }
    else {
      //one or two sidelengths are missing, let's calculate them
      //when the last unknown segmentlength is the last, start at the front
      let start = ((diff > 1 ? firstOcc : lastOcc) + 1) % points.value;
      calcMissingSidelenghts(start);
    }
  }
  //All side lengths and angles are given and correct (hopefully) so we create them:
  return valid;
}

/**
 * Given atleast 3 consecutive sidelenghts and all angles (currentFamily) for a 5-sided-polygon, calculate the remaining sidelenghts
 * @param start defines where to start the calculation for the missing side length. The next 3 sides from this point on need to be defined
 */
const calcMissingSidelenghts = (start) => {
  let angls = currentFamily.value.angles;
  let strks = currentFamily.value.strokes;
  let strksC = points.value;
  let famId = currentFamily.value.id

  let X, Y, b1, b2, b3, c1, c2, E1, f1, a1;
  switch (famId) {
      //Es reicht hier drin aus die Winkel zu berechnen und dann
      //mit dem Algo fortzufahren
    case 7:
      X = lawOfCosine(strks[2], strks[3], angls[2]);
      b1 = (180 - angls[2]) / 2;
      Y = lawOfCosine(strks[3], X, angls[3] - b1);

      f1 = Math.sin(degreeToRadian(angls[3] - b1)) * strks[1];
      b2 = radianToDegree(Math.asin(f1 / Y));
      // console.log(X, b1, Y, b2);

      f1 = Math.sin(degreeToRadian(angls[0])) * strks[1];
      E1 = radianToDegree(Math.asin(f1 / Y));
      // console.log(E1);

      b3 = 180 - angls[0] - E1;
      // console.log(b3);

      currentFamily.value.angles[1] = b1 + b2 + b3;
      currentFamily.value.angles[4] = (360 - angls[1]) / 2;
      //fine, I'll do it myself
      currentFamily.value.strokes[0] = (Math.sin(degreeToRadian(b3)) * Y / Math.sin(degreeToRadian(angls[0])));
      // console.log(Math.sin(degreeToRadian(b3)) * Y / Math.sin(degreeToRadian(angls[0])));
      // console.log(strks);
      // console.log(angls);
      return;
    case 8:
      X = lawOfCosine(strks[2], strks[3], angls[2]);
      b1 = (180 - angls[2]) / 2;
      Y = lawOfCosine(strks[1], X, angls[1] - b1);
      //console.log(X, b1, Y);

      f1 = Math.sin(degreeToRadian(angls[1] - b1)) * strks[1];
      b2 = radianToDegree(Math.asin(f1 / Y));
      //console.log(f1, b2);

      a1 = 180 - angls[1] + b1 - b2;
      //console.log(a1, angls[1], b2, b2);

      f1 = Y * Math.sin(degreeToRadian(angls[0] - a1));
      currentFamily.value.angles[4] = 180 - radianToDegree(Math.asin(f1 / strks[4]));
      //console.log(a1, f1, angls[4]);

      b3 = 180 - angls[0] - a1;
      currentFamily.value.angles[3] = b1 + b2 + b3;
      f1 = strks[4] * Math.sin(b3);
      currentFamily.value.strokes[0] = f1 / Math.sin(angls[0] - a1);
      return;
    case 10:
      X = lawOfCosine(strks[0], strks[1], angls[0]);
      b1 = (180 - angls[0]) / 2;
      Y = lawOfCosine(strks[2], X, angls[1] - b1);

      f1 = Math.sin(degreeToRadian(angls[1] - b1)) * X;
      f1 = Y * Y + X * X - strks[2] * strks[2];
      f1 /= 2 * Y * X;
      b2 = radianToDegree(Math.acos(f1));
      c1 = 180 - angls[1] + b1 - b2;


      c2 = angls[2] - c1;
      b3 = angls[4] - b1 - b2;

      currentFamily.value.angles[3] = 180 - c2 - b3;
      f1 = Math.sin(degreeToRadian(b3)) * strks[2]
      currentFamily.value.strokes[3] = f1 / Math.sin(degreeToRadian(c2));

      //console.log("X", X, "b1", b1, "Y", Y, "b2", b2, "c1", c1, "c2", c2, "b3", b3, strks[3], angls[3]);

      return;
      /*case 11:

        return;
     *case 12:

        return;
    */
  }
  //kein return, weil der algo hier nach einfach die fehlende Seite ausrechnet

  let left = strks[start];
  // console.log("left stroke:", left)
  let alpha = angls[start];
  start = mod(start + 1, strksC);

  let right = currentFamily.value.strokes[start], bottom;
  let beta, gamma;
  let lastAng = 0;

  for (let i = 0; i < 2; i++) {
    //cosine rule
    bottom = lawOfCosine(left, right, alpha);
    //sine rule
    let h = Math.sin(degreeToRadian(alpha)) / bottom;

    beta = radianToDegree(Math.asin(h * right));
    gamma = 180 - beta - alpha;//radianToDegree(Math.asin(h * left)); //ICH HASSE LAW OF SINES AMBIGUITY
    alpha = angls[start] - gamma;
    start = mod(start + 1, strksC);
    right = strks[start];
    lastAng += beta;
    // noinspection JSSuspiciousNameCombination
    left = bottom;
  }
  //wenn beta === gamma ist, muss man an die beiden unbekannten seiten den gleichen wert zuweisen
  let h = Math.sin(degreeToRadian(angls[start])) / left;

  //für diese beiden Familien muss ein gleichseitiges Dreieck erzeugt werden
  if(famId === 3 || famId === 6) {
    let desiredTopAngle = currentFamily.value.angles[famId === 3 ? 0 : 1];
    let bottomAngle = (180 - desiredTopAngle) / 2;
    let hypotenuse = left * Math.sin(degreeToRadian(bottomAngle)) / Math.sin(degreeToRadian(desiredTopAngle));

    currentFamily.value.strokes[famId === 3 ? 0 : 1] =
        currentFamily.value.strokes[famId === 3 ? 1 : 2] = hypotenuse;
    currentFamily.value.angles[famId === 3 ? 1 : 2] = bottomAngle + lastAng;
    currentFamily.value.angles[famId === 3 ? 4 : 0] = bottomAngle + gamma;

    return;
  }

  lastAng = angls[mod(start + 1, strksC)] - lastAng;

  //Es waren im Vorfeld schon 4 Seiten gegeben,...
  //...also wir haben nun mehr oder Möglichkeiten die einzig verbliebene Seite zu berechnen
  if(right !== undefined) {
    currentFamily.value.strokes[mod(start + 1, strksC)] = lawOfCosine(left, right, alpha);
    return;
  }

  for (let ang of [lastAng, alpha]) {
    currentFamily.value.strokes[start] = Math.sin(degreeToRadian(ang)) / h;
    start = mod(start + 1, strksC);
  }
}

/**
 * moves the polygon's center to a new desired location
 * @param polygon the polygon to be moved
 * @param newCenter the polygon's new center location
 */
const setNewCenter = (polygon, newCenter) => {
  let centerOfPolygon = calcCenter(polygon)
  //entweder neuen mittelpunkt setzen oder jeden Punkt um einen Wert/Punkt verschieben

  //calc how much to move every point by
  let diff = centerOfPolygon.subtract(newCenter);

  movePolygon(polygon, diff.multiply(-1))
}

/**
 * returns the middlepoint for a given polygon
 * @param polygon polygon to calculate the center of
 * @returns {paper.Point} centerpoint
 */
const calcCenter = (polygon) => {
  let centerOfPolygon = new Point(0, 0)
  //calc current centerpoint
  for (let i = 0; i < points.value; i++) {
    centerOfPolygon = polygon.segments[i].point.add(centerOfPolygon)
  }
  return centerOfPolygon.divide(points.value)
}

/**
 * moves a polygon such that each point defining the polygon gets moved by a defined amount
 * @param polygon the polygon to be moved
 * @param offset the point defining the movement of the polygon
 */
const movePolygon = (polygon, offset) => {
  polygon.position = polygon.position.add(offset);
}

const findUndefined = (obj) => {
  return obj === undefined;
}

/**
 * find out if two numbers are the same with a certain tolerance
 * @param num1 first number
 * @param num2 second number
 * @param prec desired precision
 * @returns {boolean} about equal
 */
function equals(num1, num2, prec = 0.000001) {
  return Math.abs(num1 - num2) < prec;
}

</script>

<style scoped>
@import '../../main.css';
</style>
